Subject: Re: [PATCH] Allow to control the namespace for replace refs

From: Junio C Hamano <[email-masked]>
Date: Thu, 11 Jun 2015 08:16:02 -0700

Mike Hommey <[email-masked]> writes:

> I do agree that this is all confusing, but allow me to point out that
> it's already plenty confusing: "namespace" is a term that has been used to
> designate a generic kind of namespace *and* refs/namespaces. See for
> example:
>
> https://github.com/git/git/blob/master/Documentation/git-describe.txt#L39
> https://github.com/git/git/blob/master/Documentation/git-fetch.txt#L113
> https://github.com/git/git/blob/master/Documentation/git-filter-branch.txt#L36
> (note how this one is specifically about refs/replace/)
> there are many more.

"One more breakage does not hurt" is not something we want to see.

> _REF kind of implies _one_ specific ref....

I thought about suggesting GIT_REPLACE_REFS for that exact reason,
but decided against it, because (1) if you are using replace, then
you know you are not using a single ref but a group of refs in a
single hierarchy already, and (2) if you do not know what replace
and notes are, GIT_REPLACE_REFS and GIT_NOTES_REF look just being
inconsistent (even though the intention of the difference is to be
more logical).  s/S/_BASE/ would make that better, though.

> As for exposing a pref, I'm not entirely sure it makes sense to.

I don't see an immediate need for it, and it is easy to add later,
so let's limit the scope of the initial adoption of the feature.

Thanks.